#include<stdio.h>

#define MAXFCT 15
#define MAXLEV 15
#define MAXADR 1023
#define STACKSIZE 1000 


typedef struct{
   char f;
   char l;
   short a; 
}Instruction;

extern Instruction code[MAXADR+1];

int b;
int s[STACKSIZE-1]; 


int base(l)
   int l;
{
   int b1;
   b1 = b;
   while(l > 0){
      b1 = s[b1];
      l = l-1;
   }
   return b1;
}

Interpret()
{
   int  p,t,m;
   Instruction i;
   t = 0; b = 1;p = 0;
   s[1] = 0;s[2] = 0; s[3] = 0;
   
 /*  printf("m    :code.f:code.l:code.a\n");  
   for(m=0;m<50;m++)
      printf("%6d:%6d:%6d:%6d\n",p,code[m].f,code[m].l,code[m].a); 
   */
   do{   
     /*  printf("%6d:%6d:%6d:%6d\n",p,code[p].f,code[p].l,code[p].a);
         */
       i = code[p];
       p++;
       switch(i.f){
          case 0: t++; s[t] = i.a; break;
          case 1: switch(i.a){
             case 0:  t = b-1; p = s[t+3]; b = s[t+2]; break;
             case 1:  s[t] = -s[t]; break;
             case 2:  t--; s[t] = s[t] + s[t+1]; break;
             case 3:  t--; s[t] = s[t] - s[t+1]; break;
             case 4:  t--; s[t] = s[t] * s[t+1]; break;
             case 5:  t--; s[t] = s[t] / s[t+1]; break;
             case 6:  s[t] = s[t] % 2; break;
             case 7:  break;
             case 8:  t--; s[t] = (s[t] == s[t+1]); break;
             case 9:  t--; s[t] = (s[t] != s[t+1]); break;
             case 10: t--; s[t] = (s[t] < s[t+1]); break;
             case 11: t--; s[t] = (s[t] >= s[t+1]); break;
             case 12: t--; s[t] = (s[t] > s[t+1]); break;
             case 13: t--; s[t] = (s[t] <= s[t+1]); break;
             case 14: t++; 
                      printf(">");
                      scanf("%d",&s[t]);      
                     if(s[t] == EOF){
                        p = 0;
                     }
                      break;
             case 15:printf(" %d\n",s[t]); t--; break;
          }break;
         case 2: t++;s[t] = s[base(i.l,s) + (int)i.a]; break;
         case 3: s[base(i.l,s)+ (int)i.a] = s[t]; t--;break; 
         case 4: s[t+1] = base(i.l,s);
                 s[t+2] = b; 
                 s[t+3] = p;
                 b = t+1; 
                 p = i.a; break;
         case 5: t = t+(int)i.a; break;
         case 6: p =i.a; break;
         case 7: if(s[t] == 0)
                   p = i.a;
                   t--; break;
       }
    }while(p != 0);
}

EndInterpreter()
{
}


